net.sf.saxon.option.jdom2

## Class JDOM2NodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.jdom2.JDOM2NodeWrapper

- All Implemented Interfaces:
    Source, PullEvent, Item, NodeInfo, Sequence, SiblingCountingNode, VirtualNode
  Direct Known Subclasses:
    JDOM2DocumentWrapper

      public class JDOM2NodeWrapper
      extends AbstractNodeWrapper
      implements SiblingCountingNode

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This is the implementation of the NodeInfo interface used as a wrapper for JDOM2 nodes.

  Author:
    Michael H. Kay

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JDOM2DocumentWrapper` | `docWrapper`
    `protected int` | `index`
    `protected Object` | `node`
    `protected short` | `nodeKind`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JDOM2NodeWrapper(Object node, JDOM2NodeWrapper parent, int index)` This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
    `void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
    `void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
    `String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
    `int` | `getColumnNumber()` Get column number
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `String` | `getDisplayName()` Get the display name of this node.
    `long` | `getDocumentNumber()` Get the document number of the document containing this node.
    `DocumentInfo` | `getDocumentRoot()` Get the root (document) node
    `int` | `getLineNumber()` Get line number
    `String` | `getLocalPart()` Get the local part of the name of this node.
    `int` | `getNodeKind()` Return the type of node.
    `NodeInfo` | `getParent()` Get the NodeInfo object representing the parent of this node
    `String` | `getPrefix()` Get the prefix part of the name of this node.
    `NodeInfo` | `getRoot()` Get the root node - always a document node with this tree implementation
    `int` | `getSiblingPosition()` Get the index position of this node among its siblings (starting from 0) In the case of a text node that maps to several adjacent siblings in the JDOM, the numbering actually refers to the position of the underlying JDOM nodes; thus the sibling position for the text node is that of the first JDOM node to which it relates, and the numbering of subsequent XPath nodes is not necessarily consecutive.
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `Object` | `getUnderlyingNode()` Get the underlying JDOM node, to implement the VirtualNode interface
    `String` | `getURI()` Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` Determine whether the node has any children.
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isIdref()` Determine whether this node has the is-idref property
    `protected AxisIterator<NodeInfo>` | `iterateAttributes(NodeTest nodeTest)` Return an iterator over the attributes of this element node.
    `protected AxisIterator<NodeInfo>` | `iterateChildren(NodeTest nodeTest)` Return an iterator over the children of this node.
    `protected AxisIterator<NodeInfo>` | `iterateDescendants(NodeTest nodeTest, boolean includeSelf)` Return an iterator over the descendants of this node.
    `protected AxisIterator<NodeInfo>` | `iterateSiblings(NodeTest nodeTest, boolean forwards)` Return an iterator over the siblings of this node.
    `protected JDOM2NodeWrapper` | `makeWrapper(Object node, JDOM2DocumentWrapper docWrapper)` Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
    `protected JDOM2NodeWrapper` | `makeWrapper(Object node, JDOM2DocumentWrapper docWrapper, JDOM2NodeWrapper parent, int index)` Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `atomize, comparePosition, equals, getBaseURI, getConfiguration, getFingerprint, getNameCode, getNamePool, getRealNode, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, hashCode, head, isNilled, isSameNodeInfo, iterate, iterateAxis, iterateAxis, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, comparePosition, equals, getBaseURI, getConfiguration, getFingerprint, getNameCode, getNamePool, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, hashCode, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

    - ### Methods inherited from interface javax.xml.transform.Source

      `setSystemId`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `head, iterate`

- - ### Field Detail

    - #### node

          protected Object node

    - #### nodeKind

          protected short nodeKind

    - #### docWrapper

          protected JDOM2DocumentWrapper docWrapper

    - #### index

          protected int index

  - ### Constructor Detail

    - #### JDOM2NodeWrapper

          protected JDOM2NodeWrapper(Object node,
                          JDOM2NodeWrapper parent,
                          int index)

      This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class
      Parameters:
        `node` - The JDOM node to be wrapped
        `parent` - The NodeWrapper that wraps the parent of this node
        `index` - Position of this node among its siblings

  - ### Method Detail

    - #### makeWrapper

          protected JDOM2NodeWrapper makeWrapper(Object node,
                                     JDOM2DocumentWrapper docWrapper)

      Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The JDOM node
        `docWrapper` - The wrapper for the Document containing this node
      Returns:
        The new wrapper for the supplied node

    - #### makeWrapper

          protected JDOM2NodeWrapper makeWrapper(Object node,
                                     JDOM2DocumentWrapper docWrapper,
                                     JDOM2NodeWrapper parent,
                                     int index)

      Factory method to wrap a JDOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The JDOM node
        `docWrapper` - The wrapper for the Document containing this node
        `parent` - The wrapper for the parent of the JDOM node
        `index` - The position of this node relative to its siblings
      Returns:
        The new wrapper for the supplied node

    - #### getUnderlyingNode

          public Object getUnderlyingNode()

      Get the underlying JDOM node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### compareOrder

          public int compareOrder(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLineNumber

          public int getLineNumber()

      Description copied from class: `AbstractNodeWrapper`
      Get line number
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Overrides:
        `getLineNumber` in class `AbstractNodeWrapper`
      Returns:
        the line number of the node in its original source document; or -1 if not available. Always returns -1 in this implementation.

    - #### getColumnNumber

          public int getColumnNumber()

      Description copied from class: `AbstractNodeWrapper`
      Get column number
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Overrides:
        `getColumnNumber` in class `AbstractNodeWrapper`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### getLocalPart

          public String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getPrefix

          public String getPrefix()

      Get the prefix part of the name of this node. This is the name before the ":" if any. (Note, this method isn't required as part of the NodeInfo interface.)
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        the prefix part of the name. For an unnamed node, return an empty string.

    - #### getURI

          public String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

    - #### getDisplayName

          public String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0) In the case of a text node that maps to several adjacent siblings in the JDOM, the numbering actually refers to the position of the underlying JDOM nodes; thus the sibling position for the text node is that of the first JDOM node to which it relates, and the numbering of subsequent XPath nodes is not necessarily consecutive.
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator<NodeInfo> iterateAttributes(NodeTest nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the attributes of this element node. This method is only called after checking that the node is an element.
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the attribute nodes. The order of the result, although arbitrary, must be consistent with document order.

    - #### iterateChildren

          protected AxisIterator<NodeInfo> iterateChildren(NodeTest nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator<NodeInfo> iterateSiblings(NodeTest nodeTest,
                                               boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator<NodeInfo> iterateDescendants(NodeTest nodeTest,
                                                  boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Specified by:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        8.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node - always a document node with this tree implementation
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the containing document

    - #### getDocumentRoot

          public DocumentInfo getDocumentRoot()

      Get the root (document) node
      Specified by:
        `getDocumentRoot` in interface `NodeInfo`
      Returns:
        the DocumentInfo representing the containing document

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Note: the result is equivalent to
      getEnumeration(AxisInfo.CHILD, AnyNodeTest.getInstance()).hasNext()
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a Buffer to contain a string that uniquely identifies this node, across all documents

    - #### getDocumentNumber

          public long getDocumentNumber()

      Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.
      Specified by:
        `getDocumentNumber` in interface `NodeInfo`
      Overrides:
        `getDocumentNumber` in class `AbstractNodeWrapper`
      Returns:
        the document number of the document containing this node

    - #### copy

          public void copy(Receiver out,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given outputter (deep copy)
      Specified by:
        `copy` in interface `NodeInfo`
      Overrides:
        `copy` in class `AbstractNodeWrapper`
      Parameters:
        `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Overrides:
        `isId` in class `AbstractNodeWrapper`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Overrides:
        `isIdref` in class `AbstractNodeWrapper`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.